#include <vector>
#include <iostream>
#include <fstream>
#include <utility>

#define REP(i,n) for(unsigned int i=0;i<(n);i++)

using namespace std;

class TestIO{
protected:
  unsigned int result;
  unsigned int n,k;
  vector<vector<int> > imps;
public:
  TestIO(istream &is) : result(0){
    is >> n >> k;
    imps = vector<vector<int> >(k,vector<int>(n));
    REP(i,k)
      REP(j,n){
	is >> imps[i][j];
    }
  };
  
  friend ostream& operator<<(ostream &os, const TestIO &data){
    if (data.result)
      return os << "YES" << endl;
    else
      return os << "NO" << endl;
  };
};

class Graph{
private:
  vector<bool> isVisited;
  vector<int> visited;
protected:
  int n;
  vector<vector<int> > edges; 
public:
  Graph(int _n) : n(_n), edges(vector<vector<int> >(_n)){}
  void addEdge(int v1,int v2){
    edges[v1].push_back(v2);
  }
  
  void visit(int v){
    if (isVisited[v])
      return;
    isVisited[v] = true;
    visited.push_back(v);
    REP(i,edges[v].size())
      visit(edges[v][i]);
  }

  vector<int> dfs(vector<int> start){
    isVisited = vector<bool>(n,false); 
    visited = vector<int>(0);
    REP(i,start.size())
      visit(start[i]);
    return visited;
  }
};

class Solver : public TestIO{
public:
  Solver(istream &is) : TestIO(is){}
  
  int reach0(){
    Graph g(n);
    REP(i,k) REP(j,n)
      g.addEdge(imps[i][j],j);
    
    return (g.dfs(vector<int>(1,0)).size() == n);
  }

  int pair2Int(pair<int,int> p){ return p.first*n + p.second;}

  pair<int,int> int2Pair(int i){ return pair<int,int>(i/n,i%n);}

  int revReachAll(){
    Graph g(n*n);
    REP(i,k) REP(j1,n) REP(j2,n)
      g.addEdge( pair2Int(pair<int,int>(imps[i][j1],imps[i][j2])),pair2Int(pair<int,int>(j1,j2)));
    
    vector<int> start(1,0);
    //    REP(i,n) start.push_back(pair2Int(pair<int,int>(i,i)));

    return (g.dfs(start).size() == n*n);
  }

  int solve(){
    //    cerr << reach0() << " " << revReachAll() << endl;
    //    return (result = reach0() && revReachAll());
    //    cerr << revReachAll();
    return (result = revReachAll());
  }
};



int main(){
  ifstream inFile("bit2.in");
  ofstream outFile("bit2.out");

  unsigned int T;
  inFile >> T;
  REP(i,T){
    Solver solver(inFile);
    solver.solve();
    outFile << solver;
  }
  return 0;
}
